import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { SMITHY_CONTEXT_KEY, } from "@smithy/types";
import { ListMediaPipelineKinesisVideoStreamPoolsResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListMediaPipelineKinesisVideoStreamPoolsCommand, se_ListMediaPipelineKinesisVideoStreamPoolsCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class ListMediaPipelineKinesisVideoStreamPoolsCommand extends $Command {
    static getEndpointParameterInstructions() {
        return {
            UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
            Endpoint: { type: "builtInParams", name: "endpoint" },
            Region: { type: "builtInParams", name: "region" },
            UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" },
        };
    }
    constructor(input) {
        super();
        this.input = input;
    }
    resolveMiddleware(clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointPlugin(configuration, ListMediaPipelineKinesisVideoStreamPoolsCommand.getEndpointParameterInstructions()));
        const stack = clientStack.concat(this.middlewareStack);
        const { logger } = configuration;
        const clientName = "ChimeSDKMediaPipelinesClient";
        const commandName = "ListMediaPipelineKinesisVideoStreamPoolsCommand";
        const handlerExecutionContext = {
            logger,
            clientName,
            commandName,
            inputFilterSensitiveLog: (_) => _,
            outputFilterSensitiveLog: ListMediaPipelineKinesisVideoStreamPoolsResponseFilterSensitiveLog,
            [SMITHY_CONTEXT_KEY]: {
                service: "ChimeSDKMediaPipelinesService",
                operation: "ListMediaPipelineKinesisVideoStreamPools",
            },
        };
        const { requestHandler } = configuration;
        return stack.resolve((request) => requestHandler.handle(request.request, options || {}), handlerExecutionContext);
    }
    serialize(input, context) {
        return se_ListMediaPipelineKinesisVideoStreamPoolsCommand(input, context);
    }
    deserialize(output, context) {
        return de_ListMediaPipelineKinesisVideoStreamPoolsCommand(output, context);
    }
}
