import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  ChimeSDKMediaPipelinesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ChimeSDKMediaPipelinesClient";
import {
  CreateMediaPipelineKinesisVideoStreamPoolRequest,
  CreateMediaPipelineKinesisVideoStreamPoolResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface CreateMediaPipelineKinesisVideoStreamPoolCommandInput
  extends CreateMediaPipelineKinesisVideoStreamPoolRequest {}
export interface CreateMediaPipelineKinesisVideoStreamPoolCommandOutput
  extends CreateMediaPipelineKinesisVideoStreamPoolResponse,
    __MetadataBearer {}
export declare class CreateMediaPipelineKinesisVideoStreamPoolCommand extends $Command<
  CreateMediaPipelineKinesisVideoStreamPoolCommandInput,
  CreateMediaPipelineKinesisVideoStreamPoolCommandOutput,
  ChimeSDKMediaPipelinesClientResolvedConfig
> {
  readonly input: CreateMediaPipelineKinesisVideoStreamPoolCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: CreateMediaPipelineKinesisVideoStreamPoolCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ChimeSDKMediaPipelinesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    CreateMediaPipelineKinesisVideoStreamPoolCommandInput,
    CreateMediaPipelineKinesisVideoStreamPoolCommandOutput
  >;
  private serialize;
  private deserialize;
}
