import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  ChimeSDKMediaPipelinesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ChimeSDKMediaPipelinesClient";
import {
  CreateMediaStreamPipelineRequest,
  CreateMediaStreamPipelineResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface CreateMediaStreamPipelineCommandInput
  extends CreateMediaStreamPipelineRequest {}
export interface CreateMediaStreamPipelineCommandOutput
  extends CreateMediaStreamPipelineResponse,
    __MetadataBearer {}
export declare class CreateMediaStreamPipelineCommand extends $Command<
  CreateMediaStreamPipelineCommandInput,
  CreateMediaStreamPipelineCommandOutput,
  ChimeSDKMediaPipelinesClientResolvedConfig
> {
  readonly input: CreateMediaStreamPipelineCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: CreateMediaStreamPipelineCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ChimeSDKMediaPipelinesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    CreateMediaStreamPipelineCommandInput,
    CreateMediaStreamPipelineCommandOutput
  >;
  private serialize;
  private deserialize;
}
