import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  ChimeSDKMediaPipelinesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ChimeSDKMediaPipelinesClient";
import {
  GetMediaPipelineKinesisVideoStreamPoolRequest,
  GetMediaPipelineKinesisVideoStreamPoolResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface GetMediaPipelineKinesisVideoStreamPoolCommandInput
  extends GetMediaPipelineKinesisVideoStreamPoolRequest {}
export interface GetMediaPipelineKinesisVideoStreamPoolCommandOutput
  extends GetMediaPipelineKinesisVideoStreamPoolResponse,
    __MetadataBearer {}
export declare class GetMediaPipelineKinesisVideoStreamPoolCommand extends $Command<
  GetMediaPipelineKinesisVideoStreamPoolCommandInput,
  GetMediaPipelineKinesisVideoStreamPoolCommandOutput,
  ChimeSDKMediaPipelinesClientResolvedConfig
> {
  readonly input: GetMediaPipelineKinesisVideoStreamPoolCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetMediaPipelineKinesisVideoStreamPoolCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ChimeSDKMediaPipelinesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    GetMediaPipelineKinesisVideoStreamPoolCommandInput,
    GetMediaPipelineKinesisVideoStreamPoolCommandOutput
  >;
  private serialize;
  private deserialize;
}
