import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  ChimeSDKMediaPipelinesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ChimeSDKMediaPipelinesClient";
import {
  GetVoiceToneAnalysisTaskRequest,
  GetVoiceToneAnalysisTaskResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface GetVoiceToneAnalysisTaskCommandInput
  extends GetVoiceToneAnalysisTaskRequest {}
export interface GetVoiceToneAnalysisTaskCommandOutput
  extends GetVoiceToneAnalysisTaskResponse,
    __MetadataBearer {}
export declare class GetVoiceToneAnalysisTaskCommand extends $Command<
  GetVoiceToneAnalysisTaskCommandInput,
  GetVoiceToneAnalysisTaskCommandOutput,
  ChimeSDKMediaPipelinesClientResolvedConfig
> {
  readonly input: GetVoiceToneAnalysisTaskCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetVoiceToneAnalysisTaskCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ChimeSDKMediaPipelinesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    GetVoiceToneAnalysisTaskCommandInput,
    GetVoiceToneAnalysisTaskCommandOutput
  >;
  private serialize;
  private deserialize;
}
