import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  ChimeSDKMediaPipelinesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ChimeSDKMediaPipelinesClient";
import {
  ListMediaPipelineKinesisVideoStreamPoolsRequest,
  ListMediaPipelineKinesisVideoStreamPoolsResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListMediaPipelineKinesisVideoStreamPoolsCommandInput
  extends ListMediaPipelineKinesisVideoStreamPoolsRequest {}
export interface ListMediaPipelineKinesisVideoStreamPoolsCommandOutput
  extends ListMediaPipelineKinesisVideoStreamPoolsResponse,
    __MetadataBearer {}
export declare class ListMediaPipelineKinesisVideoStreamPoolsCommand extends $Command<
  ListMediaPipelineKinesisVideoStreamPoolsCommandInput,
  ListMediaPipelineKinesisVideoStreamPoolsCommandOutput,
  ChimeSDKMediaPipelinesClientResolvedConfig
> {
  readonly input: ListMediaPipelineKinesisVideoStreamPoolsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListMediaPipelineKinesisVideoStreamPoolsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ChimeSDKMediaPipelinesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListMediaPipelineKinesisVideoStreamPoolsCommandInput,
    ListMediaPipelineKinesisVideoStreamPoolsCommandOutput
  >;
  private serialize;
  private deserialize;
}
