import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  ChimeSDKMediaPipelinesClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ChimeSDKMediaPipelinesClient";
import {
  UpdateMediaPipelineKinesisVideoStreamPoolRequest,
  UpdateMediaPipelineKinesisVideoStreamPoolResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface UpdateMediaPipelineKinesisVideoStreamPoolCommandInput
  extends UpdateMediaPipelineKinesisVideoStreamPoolRequest {}
export interface UpdateMediaPipelineKinesisVideoStreamPoolCommandOutput
  extends UpdateMediaPipelineKinesisVideoStreamPoolResponse,
    __MetadataBearer {}
export declare class UpdateMediaPipelineKinesisVideoStreamPoolCommand extends $Command<
  UpdateMediaPipelineKinesisVideoStreamPoolCommandInput,
  UpdateMediaPipelineKinesisVideoStreamPoolCommandOutput,
  ChimeSDKMediaPipelinesClientResolvedConfig
> {
  readonly input: UpdateMediaPipelineKinesisVideoStreamPoolCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateMediaPipelineKinesisVideoStreamPoolCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ChimeSDKMediaPipelinesClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    UpdateMediaPipelineKinesisVideoStreamPoolCommandInput,
    UpdateMediaPipelineKinesisVideoStreamPoolCommandOutput
  >;
  private serialize;
  private deserialize;
}
