"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KinesisVideo = void 0;
const smithy_client_1 = require("@smithy/smithy-client");
const CreateSignalingChannelCommand_1 = require("./commands/CreateSignalingChannelCommand");
const CreateStreamCommand_1 = require("./commands/CreateStreamCommand");
const DeleteEdgeConfigurationCommand_1 = require("./commands/DeleteEdgeConfigurationCommand");
const DeleteSignalingChannelCommand_1 = require("./commands/DeleteSignalingChannelCommand");
const DeleteStreamCommand_1 = require("./commands/DeleteStreamCommand");
const DescribeEdgeConfigurationCommand_1 = require("./commands/DescribeEdgeConfigurationCommand");
const DescribeImageGenerationConfigurationCommand_1 = require("./commands/DescribeImageGenerationConfigurationCommand");
const DescribeMappedResourceConfigurationCommand_1 = require("./commands/DescribeMappedResourceConfigurationCommand");
const DescribeMediaStorageConfigurationCommand_1 = require("./commands/DescribeMediaStorageConfigurationCommand");
const DescribeNotificationConfigurationCommand_1 = require("./commands/DescribeNotificationConfigurationCommand");
const DescribeSignalingChannelCommand_1 = require("./commands/DescribeSignalingChannelCommand");
const DescribeStreamCommand_1 = require("./commands/DescribeStreamCommand");
const GetDataEndpointCommand_1 = require("./commands/GetDataEndpointCommand");
const GetSignalingChannelEndpointCommand_1 = require("./commands/GetSignalingChannelEndpointCommand");
const ListEdgeAgentConfigurationsCommand_1 = require("./commands/ListEdgeAgentConfigurationsCommand");
const ListSignalingChannelsCommand_1 = require("./commands/ListSignalingChannelsCommand");
const ListStreamsCommand_1 = require("./commands/ListStreamsCommand");
const ListTagsForResourceCommand_1 = require("./commands/ListTagsForResourceCommand");
const ListTagsForStreamCommand_1 = require("./commands/ListTagsForStreamCommand");
const StartEdgeConfigurationUpdateCommand_1 = require("./commands/StartEdgeConfigurationUpdateCommand");
const TagResourceCommand_1 = require("./commands/TagResourceCommand");
const TagStreamCommand_1 = require("./commands/TagStreamCommand");
const UntagResourceCommand_1 = require("./commands/UntagResourceCommand");
const UntagStreamCommand_1 = require("./commands/UntagStreamCommand");
const UpdateDataRetentionCommand_1 = require("./commands/UpdateDataRetentionCommand");
const UpdateImageGenerationConfigurationCommand_1 = require("./commands/UpdateImageGenerationConfigurationCommand");
const UpdateMediaStorageConfigurationCommand_1 = require("./commands/UpdateMediaStorageConfigurationCommand");
const UpdateNotificationConfigurationCommand_1 = require("./commands/UpdateNotificationConfigurationCommand");
const UpdateSignalingChannelCommand_1 = require("./commands/UpdateSignalingChannelCommand");
const UpdateStreamCommand_1 = require("./commands/UpdateStreamCommand");
const KinesisVideoClient_1 = require("./KinesisVideoClient");
const commands = {
    CreateSignalingChannelCommand: CreateSignalingChannelCommand_1.CreateSignalingChannelCommand,
    CreateStreamCommand: CreateStreamCommand_1.CreateStreamCommand,
    DeleteEdgeConfigurationCommand: DeleteEdgeConfigurationCommand_1.DeleteEdgeConfigurationCommand,
    DeleteSignalingChannelCommand: DeleteSignalingChannelCommand_1.DeleteSignalingChannelCommand,
    DeleteStreamCommand: DeleteStreamCommand_1.DeleteStreamCommand,
    DescribeEdgeConfigurationCommand: DescribeEdgeConfigurationCommand_1.DescribeEdgeConfigurationCommand,
    DescribeImageGenerationConfigurationCommand: DescribeImageGenerationConfigurationCommand_1.DescribeImageGenerationConfigurationCommand,
    DescribeMappedResourceConfigurationCommand: DescribeMappedResourceConfigurationCommand_1.DescribeMappedResourceConfigurationCommand,
    DescribeMediaStorageConfigurationCommand: DescribeMediaStorageConfigurationCommand_1.DescribeMediaStorageConfigurationCommand,
    DescribeNotificationConfigurationCommand: DescribeNotificationConfigurationCommand_1.DescribeNotificationConfigurationCommand,
    DescribeSignalingChannelCommand: DescribeSignalingChannelCommand_1.DescribeSignalingChannelCommand,
    DescribeStreamCommand: DescribeStreamCommand_1.DescribeStreamCommand,
    GetDataEndpointCommand: GetDataEndpointCommand_1.GetDataEndpointCommand,
    GetSignalingChannelEndpointCommand: GetSignalingChannelEndpointCommand_1.GetSignalingChannelEndpointCommand,
    ListEdgeAgentConfigurationsCommand: ListEdgeAgentConfigurationsCommand_1.ListEdgeAgentConfigurationsCommand,
    ListSignalingChannelsCommand: ListSignalingChannelsCommand_1.ListSignalingChannelsCommand,
    ListStreamsCommand: ListStreamsCommand_1.ListStreamsCommand,
    ListTagsForResourceCommand: ListTagsForResourceCommand_1.ListTagsForResourceCommand,
    ListTagsForStreamCommand: ListTagsForStreamCommand_1.ListTagsForStreamCommand,
    StartEdgeConfigurationUpdateCommand: StartEdgeConfigurationUpdateCommand_1.StartEdgeConfigurationUpdateCommand,
    TagResourceCommand: TagResourceCommand_1.TagResourceCommand,
    TagStreamCommand: TagStreamCommand_1.TagStreamCommand,
    UntagResourceCommand: UntagResourceCommand_1.UntagResourceCommand,
    UntagStreamCommand: UntagStreamCommand_1.UntagStreamCommand,
    UpdateDataRetentionCommand: UpdateDataRetentionCommand_1.UpdateDataRetentionCommand,
    UpdateImageGenerationConfigurationCommand: UpdateImageGenerationConfigurationCommand_1.UpdateImageGenerationConfigurationCommand,
    UpdateMediaStorageConfigurationCommand: UpdateMediaStorageConfigurationCommand_1.UpdateMediaStorageConfigurationCommand,
    UpdateNotificationConfigurationCommand: UpdateNotificationConfigurationCommand_1.UpdateNotificationConfigurationCommand,
    UpdateSignalingChannelCommand: UpdateSignalingChannelCommand_1.UpdateSignalingChannelCommand,
    UpdateStreamCommand: UpdateStreamCommand_1.UpdateStreamCommand,
};
class KinesisVideo extends KinesisVideoClient_1.KinesisVideoClient {
}
exports.KinesisVideo = KinesisVideo;
(0, smithy_client_1.createAggregatedClient)(commands, KinesisVideo);
