"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.paginateDescribeMappedResourceConfiguration = void 0;
const DescribeMappedResourceConfigurationCommand_1 = require("../commands/DescribeMappedResourceConfigurationCommand");
const KinesisVideoClient_1 = require("../KinesisVideoClient");
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new DescribeMappedResourceConfigurationCommand_1.DescribeMappedResourceConfigurationCommand(input), ...args);
};
async function* paginateDescribeMappedResourceConfiguration(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.NextToken = token;
        input["MaxResults"] = config.pageSize;
        if (config.client instanceof KinesisVideoClient_1.KinesisVideoClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected KinesisVideo | KinesisVideoClient");
        }
        yield page;
        const prevToken = token;
        token = page.NextToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
exports.paginateDescribeMappedResourceConfiguration = paginateDescribeMappedResourceConfiguration;
