import { DescribeMappedResourceConfigurationCommand, } from "../commands/DescribeMappedResourceConfigurationCommand";
import { KinesisVideoClient } from "../KinesisVideoClient";
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new DescribeMappedResourceConfigurationCommand(input), ...args);
};
export async function* paginateDescribeMappedResourceConfiguration(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.NextToken = token;
        input["MaxResults"] = config.pageSize;
        if (config.client instanceof KinesisVideoClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected KinesisVideo | KinesisVideoClient");
        }
        yield page;
        const prevToken = token;
        token = page.NextToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
