import { HostHeaderInputConfig, HostHeaderResolvedConfig } from "@aws-sdk/middleware-host-header";
import { AwsAuthInputConfig, AwsAuthResolvedConfig } from "@aws-sdk/middleware-signing";
import { UserAgentInputConfig, UserAgentResolvedConfig } from "@aws-sdk/middleware-user-agent";
import { Credentials as __Credentials } from "@aws-sdk/types";
import { RegionInputConfig, RegionResolvedConfig } from "@smithy/config-resolver";
import { EndpointInputConfig, EndpointResolvedConfig } from "@smithy/middleware-endpoint";
import { RetryInputConfig, RetryResolvedConfig } from "@smithy/middleware-retry";
import { HttpHandler as __HttpHandler } from "@smithy/protocol-http";
import { Client as __Client, DefaultsMode as __DefaultsMode, SmithyConfiguration as __SmithyConfiguration, SmithyResolvedConfiguration as __SmithyResolvedConfiguration } from "@smithy/smithy-client";
import { BodyLengthCalculator as __BodyLengthCalculator, CheckOptionalClientConfig as __CheckOptionalClientConfig, ChecksumConstructor as __ChecksumConstructor, Decoder as __Decoder, Encoder as __Encoder, HashConstructor as __HashConstructor, HttpHandlerOptions as __HttpHandlerOptions, Logger as __Logger, Provider as __Provider, Provider, StreamCollector as __StreamCollector, UrlParser as __UrlParser, UserAgent as __UserAgent } from "@smithy/types";
import { CreateSignalingChannelCommandInput, CreateSignalingChannelCommandOutput } from "./commands/CreateSignalingChannelCommand";
import { CreateStreamCommandInput, CreateStreamCommandOutput } from "./commands/CreateStreamCommand";
import { DeleteEdgeConfigurationCommandInput, DeleteEdgeConfigurationCommandOutput } from "./commands/DeleteEdgeConfigurationCommand";
import { DeleteSignalingChannelCommandInput, DeleteSignalingChannelCommandOutput } from "./commands/DeleteSignalingChannelCommand";
import { DeleteStreamCommandInput, DeleteStreamCommandOutput } from "./commands/DeleteStreamCommand";
import { DescribeEdgeConfigurationCommandInput, DescribeEdgeConfigurationCommandOutput } from "./commands/DescribeEdgeConfigurationCommand";
import { DescribeImageGenerationConfigurationCommandInput, DescribeImageGenerationConfigurationCommandOutput } from "./commands/DescribeImageGenerationConfigurationCommand";
import { DescribeMappedResourceConfigurationCommandInput, DescribeMappedResourceConfigurationCommandOutput } from "./commands/DescribeMappedResourceConfigurationCommand";
import { DescribeMediaStorageConfigurationCommandInput, DescribeMediaStorageConfigurationCommandOutput } from "./commands/DescribeMediaStorageConfigurationCommand";
import { DescribeNotificationConfigurationCommandInput, DescribeNotificationConfigurationCommandOutput } from "./commands/DescribeNotificationConfigurationCommand";
import { DescribeSignalingChannelCommandInput, DescribeSignalingChannelCommandOutput } from "./commands/DescribeSignalingChannelCommand";
import { DescribeStreamCommandInput, DescribeStreamCommandOutput } from "./commands/DescribeStreamCommand";
import { GetDataEndpointCommandInput, GetDataEndpointCommandOutput } from "./commands/GetDataEndpointCommand";
import { GetSignalingChannelEndpointCommandInput, GetSignalingChannelEndpointCommandOutput } from "./commands/GetSignalingChannelEndpointCommand";
import { ListEdgeAgentConfigurationsCommandInput, ListEdgeAgentConfigurationsCommandOutput } from "./commands/ListEdgeAgentConfigurationsCommand";
import { ListSignalingChannelsCommandInput, ListSignalingChannelsCommandOutput } from "./commands/ListSignalingChannelsCommand";
import { ListStreamsCommandInput, ListStreamsCommandOutput } from "./commands/ListStreamsCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "./commands/ListTagsForResourceCommand";
import { ListTagsForStreamCommandInput, ListTagsForStreamCommandOutput } from "./commands/ListTagsForStreamCommand";
import { StartEdgeConfigurationUpdateCommandInput, StartEdgeConfigurationUpdateCommandOutput } from "./commands/StartEdgeConfigurationUpdateCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "./commands/TagResourceCommand";
import { TagStreamCommandInput, TagStreamCommandOutput } from "./commands/TagStreamCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "./commands/UntagResourceCommand";
import { UntagStreamCommandInput, UntagStreamCommandOutput } from "./commands/UntagStreamCommand";
import { UpdateDataRetentionCommandInput, UpdateDataRetentionCommandOutput } from "./commands/UpdateDataRetentionCommand";
import { UpdateImageGenerationConfigurationCommandInput, UpdateImageGenerationConfigurationCommandOutput } from "./commands/UpdateImageGenerationConfigurationCommand";
import { UpdateMediaStorageConfigurationCommandInput, UpdateMediaStorageConfigurationCommandOutput } from "./commands/UpdateMediaStorageConfigurationCommand";
import { UpdateNotificationConfigurationCommandInput, UpdateNotificationConfigurationCommandOutput } from "./commands/UpdateNotificationConfigurationCommand";
import { UpdateSignalingChannelCommandInput, UpdateSignalingChannelCommandOutput } from "./commands/UpdateSignalingChannelCommand";
import { UpdateStreamCommandInput, UpdateStreamCommandOutput } from "./commands/UpdateStreamCommand";
import { ClientInputEndpointParameters, ClientResolvedEndpointParameters, EndpointParameters } from "./endpoint/EndpointParameters";
import { RuntimeExtension, RuntimeExtensionsConfig } from "./runtimeExtensions";
export { __Client };
/**
 * @public
 */
export type ServiceInputTypes = CreateSignalingChannelCommandInput | CreateStreamCommandInput | DeleteEdgeConfigurationCommandInput | DeleteSignalingChannelCommandInput | DeleteStreamCommandInput | DescribeEdgeConfigurationCommandInput | DescribeImageGenerationConfigurationCommandInput | DescribeMappedResourceConfigurationCommandInput | DescribeMediaStorageConfigurationCommandInput | DescribeNotificationConfigurationCommandInput | DescribeSignalingChannelCommandInput | DescribeStreamCommandInput | GetDataEndpointCommandInput | GetSignalingChannelEndpointCommandInput | ListEdgeAgentConfigurationsCommandInput | ListSignalingChannelsCommandInput | ListStreamsCommandInput | ListTagsForResourceCommandInput | ListTagsForStreamCommandInput | StartEdgeConfigurationUpdateCommandInput | TagResourceCommandInput | TagStreamCommandInput | UntagResourceCommandInput | UntagStreamCommandInput | UpdateDataRetentionCommandInput | UpdateImageGenerationConfigurationCommandInput | UpdateMediaStorageConfigurationCommandInput | UpdateNotificationConfigurationCommandInput | UpdateSignalingChannelCommandInput | UpdateStreamCommandInput;
/**
 * @public
 */
export type ServiceOutputTypes = CreateSignalingChannelCommandOutput | CreateStreamCommandOutput | DeleteEdgeConfigurationCommandOutput | DeleteSignalingChannelCommandOutput | DeleteStreamCommandOutput | DescribeEdgeConfigurationCommandOutput | DescribeImageGenerationConfigurationCommandOutput | DescribeMappedResourceConfigurationCommandOutput | DescribeMediaStorageConfigurationCommandOutput | DescribeNotificationConfigurationCommandOutput | DescribeSignalingChannelCommandOutput | DescribeStreamCommandOutput | GetDataEndpointCommandOutput | GetSignalingChannelEndpointCommandOutput | ListEdgeAgentConfigurationsCommandOutput | ListSignalingChannelsCommandOutput | ListStreamsCommandOutput | ListTagsForResourceCommandOutput | ListTagsForStreamCommandOutput | StartEdgeConfigurationUpdateCommandOutput | TagResourceCommandOutput | TagStreamCommandOutput | UntagResourceCommandOutput | UntagStreamCommandOutput | UpdateDataRetentionCommandOutput | UpdateImageGenerationConfigurationCommandOutput | UpdateMediaStorageConfigurationCommandOutput | UpdateNotificationConfigurationCommandOutput | UpdateSignalingChannelCommandOutput | UpdateStreamCommandOutput;
/**
 * @public
 */
export interface ClientDefaults extends Partial<__SmithyResolvedConfiguration<__HttpHandlerOptions>> {
    /**
     * The HTTP handler to use. Fetch in browser and Https in Nodejs.
     */
    requestHandler?: __HttpHandler;
    /**
     * A constructor for a class implementing the {@link @smithy/types#ChecksumConstructor} interface
     * that computes the SHA-256 HMAC or checksum of a string or binary buffer.
     * @internal
     */
    sha256?: __ChecksumConstructor | __HashConstructor;
    /**
     * The function that will be used to convert strings into HTTP endpoints.
     * @internal
     */
    urlParser?: __UrlParser;
    /**
     * A function that can calculate the length of a request body.
     * @internal
     */
    bodyLengthChecker?: __BodyLengthCalculator;
    /**
     * A function that converts a stream into an array of bytes.
     * @internal
     */
    streamCollector?: __StreamCollector;
    /**
     * The function that will be used to convert a base64-encoded string to a byte array.
     * @internal
     */
    base64Decoder?: __Decoder;
    /**
     * The function that will be used to convert binary data to a base64-encoded string.
     * @internal
     */
    base64Encoder?: __Encoder;
    /**
     * The function that will be used to convert a UTF8-encoded string to a byte array.
     * @internal
     */
    utf8Decoder?: __Decoder;
    /**
     * The function that will be used to convert binary data to a UTF-8 encoded string.
     * @internal
     */
    utf8Encoder?: __Encoder;
    /**
     * The runtime environment.
     * @internal
     */
    runtime?: string;
    /**
     * Disable dynamically changing the endpoint of the client based on the hostPrefix
     * trait of an operation.
     */
    disableHostPrefix?: boolean;
    /**
     * Unique service identifier.
     * @internal
     */
    serviceId?: string;
    /**
     * Enables IPv6/IPv4 dualstack endpoint.
     */
    useDualstackEndpoint?: boolean | __Provider<boolean>;
    /**
     * Enables FIPS compatible endpoints.
     */
    useFipsEndpoint?: boolean | __Provider<boolean>;
    /**
     * The AWS region to which this client will send requests
     */
    region?: string | __Provider<string>;
    /**
     * Default credentials provider; Not available in browser runtime.
     * @internal
     */
    credentialDefaultProvider?: (input: any) => __Provider<__Credentials>;
    /**
     * The provider populating default tracking information to be sent with `user-agent`, `x-amz-user-agent` header
     * @internal
     */
    defaultUserAgentProvider?: Provider<__UserAgent>;
    /**
     * Value for how many times a request will be made at most in case of retry.
     */
    maxAttempts?: number | __Provider<number>;
    /**
     * Specifies which retry algorithm to use.
     * @see https://docs.aws.amazon.com/AWSJavaScriptSDK/v3/latest/Package/-smithy-util-retry/Enum/RETRY_MODES/
     *
     */
    retryMode?: string | __Provider<string>;
    /**
     * Optional logger for logging debug/info/warn/error.
     */
    logger?: __Logger;
    /**
     * Optional extensions
     */
    extensions?: RuntimeExtension[];
    /**
     * The {@link @smithy/smithy-client#DefaultsMode} that will be used to determine how certain default configuration options are resolved in the SDK.
     */
    defaultsMode?: __DefaultsMode | __Provider<__DefaultsMode>;
}
/**
 * @public
 */
export type KinesisVideoClientConfigType = Partial<__SmithyConfiguration<__HttpHandlerOptions>> & ClientDefaults & RegionInputConfig & EndpointInputConfig<EndpointParameters> & RetryInputConfig & HostHeaderInputConfig & AwsAuthInputConfig & UserAgentInputConfig & ClientInputEndpointParameters;
/**
 * @public
 *
 *  The configuration interface of KinesisVideoClient class constructor that set the region, credentials and other options.
 */
export interface KinesisVideoClientConfig extends KinesisVideoClientConfigType {
}
/**
 * @public
 */
export type KinesisVideoClientResolvedConfigType = __SmithyResolvedConfiguration<__HttpHandlerOptions> & Required<ClientDefaults> & RuntimeExtensionsConfig & RegionResolvedConfig & EndpointResolvedConfig<EndpointParameters> & RetryResolvedConfig & HostHeaderResolvedConfig & AwsAuthResolvedConfig & UserAgentResolvedConfig & ClientResolvedEndpointParameters;
/**
 * @public
 *
 *  The resolved configuration interface of KinesisVideoClient class. This is resolved and normalized from the {@link KinesisVideoClientConfig | constructor configuration interface}.
 */
export interface KinesisVideoClientResolvedConfig extends KinesisVideoClientResolvedConfigType {
}
/**
 * @public
 * <p></p>
 */
export declare class KinesisVideoClient extends __Client<__HttpHandlerOptions, ServiceInputTypes, ServiceOutputTypes, KinesisVideoClientResolvedConfig> {
    /**
     * The resolved configuration of KinesisVideoClient class. This is resolved and normalized from the {@link KinesisVideoClientConfig | constructor configuration interface}.
     */
    readonly config: KinesisVideoClientResolvedConfig;
    constructor(...[configuration]: __CheckOptionalClientConfig<KinesisVideoClientConfig>);
    /**
     * Destroy underlying resources, like sockets. It's usually not necessary to do this.
     * However in Node.js, it's best to explicitly shut down the client's agent when it is no longer needed.
     * Otherwise, sockets might stay open for quite a long time before the server terminates them.
     */
    destroy(): void;
}
