import { HttpHandlerOptions as __HttpHandlerOptions } from "@smithy/types";
import {
  CreateSignalingChannelCommandInput,
  CreateSignalingChannelCommandOutput,
} from "./commands/CreateSignalingChannelCommand";
import {
  CreateStreamCommandInput,
  CreateStreamCommandOutput,
} from "./commands/CreateStreamCommand";
import {
  DeleteEdgeConfigurationCommandInput,
  DeleteEdgeConfigurationCommandOutput,
} from "./commands/DeleteEdgeConfigurationCommand";
import {
  DeleteSignalingChannelCommandInput,
  DeleteSignalingChannelCommandOutput,
} from "./commands/DeleteSignalingChannelCommand";
import {
  DeleteStreamCommandInput,
  DeleteStreamCommandOutput,
} from "./commands/DeleteStreamCommand";
import {
  DescribeEdgeConfigurationCommandInput,
  DescribeEdgeConfigurationCommandOutput,
} from "./commands/DescribeEdgeConfigurationCommand";
import {
  DescribeImageGenerationConfigurationCommandInput,
  DescribeImageGenerationConfigurationCommandOutput,
} from "./commands/DescribeImageGenerationConfigurationCommand";
import {
  DescribeMappedResourceConfigurationCommandInput,
  DescribeMappedResourceConfigurationCommandOutput,
} from "./commands/DescribeMappedResourceConfigurationCommand";
import {
  DescribeMediaStorageConfigurationCommandInput,
  DescribeMediaStorageConfigurationCommandOutput,
} from "./commands/DescribeMediaStorageConfigurationCommand";
import {
  DescribeNotificationConfigurationCommandInput,
  DescribeNotificationConfigurationCommandOutput,
} from "./commands/DescribeNotificationConfigurationCommand";
import {
  DescribeSignalingChannelCommandInput,
  DescribeSignalingChannelCommandOutput,
} from "./commands/DescribeSignalingChannelCommand";
import {
  DescribeStreamCommandInput,
  DescribeStreamCommandOutput,
} from "./commands/DescribeStreamCommand";
import {
  GetDataEndpointCommandInput,
  GetDataEndpointCommandOutput,
} from "./commands/GetDataEndpointCommand";
import {
  GetSignalingChannelEndpointCommandInput,
  GetSignalingChannelEndpointCommandOutput,
} from "./commands/GetSignalingChannelEndpointCommand";
import {
  ListEdgeAgentConfigurationsCommandInput,
  ListEdgeAgentConfigurationsCommandOutput,
} from "./commands/ListEdgeAgentConfigurationsCommand";
import {
  ListSignalingChannelsCommandInput,
  ListSignalingChannelsCommandOutput,
} from "./commands/ListSignalingChannelsCommand";
import {
  ListStreamsCommandInput,
  ListStreamsCommandOutput,
} from "./commands/ListStreamsCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "./commands/ListTagsForResourceCommand";
import {
  ListTagsForStreamCommandInput,
  ListTagsForStreamCommandOutput,
} from "./commands/ListTagsForStreamCommand";
import {
  StartEdgeConfigurationUpdateCommandInput,
  StartEdgeConfigurationUpdateCommandOutput,
} from "./commands/StartEdgeConfigurationUpdateCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "./commands/TagResourceCommand";
import {
  TagStreamCommandInput,
  TagStreamCommandOutput,
} from "./commands/TagStreamCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "./commands/UntagResourceCommand";
import {
  UntagStreamCommandInput,
  UntagStreamCommandOutput,
} from "./commands/UntagStreamCommand";
import {
  UpdateDataRetentionCommandInput,
  UpdateDataRetentionCommandOutput,
} from "./commands/UpdateDataRetentionCommand";
import {
  UpdateImageGenerationConfigurationCommandInput,
  UpdateImageGenerationConfigurationCommandOutput,
} from "./commands/UpdateImageGenerationConfigurationCommand";
import {
  UpdateMediaStorageConfigurationCommandInput,
  UpdateMediaStorageConfigurationCommandOutput,
} from "./commands/UpdateMediaStorageConfigurationCommand";
import {
  UpdateNotificationConfigurationCommandInput,
  UpdateNotificationConfigurationCommandOutput,
} from "./commands/UpdateNotificationConfigurationCommand";
import {
  UpdateSignalingChannelCommandInput,
  UpdateSignalingChannelCommandOutput,
} from "./commands/UpdateSignalingChannelCommand";
import {
  UpdateStreamCommandInput,
  UpdateStreamCommandOutput,
} from "./commands/UpdateStreamCommand";
import { KinesisVideoClient } from "./KinesisVideoClient";
export interface KinesisVideo {
  createSignalingChannel(
    args: CreateSignalingChannelCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateSignalingChannelCommandOutput>;
  createSignalingChannel(
    args: CreateSignalingChannelCommandInput,
    cb: (err: any, data?: CreateSignalingChannelCommandOutput) => void
  ): void;
  createSignalingChannel(
    args: CreateSignalingChannelCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateSignalingChannelCommandOutput) => void
  ): void;
  createStream(
    args: CreateStreamCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateStreamCommandOutput>;
  createStream(
    args: CreateStreamCommandInput,
    cb: (err: any, data?: CreateStreamCommandOutput) => void
  ): void;
  createStream(
    args: CreateStreamCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateStreamCommandOutput) => void
  ): void;
  deleteEdgeConfiguration(
    args: DeleteEdgeConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteEdgeConfigurationCommandOutput>;
  deleteEdgeConfiguration(
    args: DeleteEdgeConfigurationCommandInput,
    cb: (err: any, data?: DeleteEdgeConfigurationCommandOutput) => void
  ): void;
  deleteEdgeConfiguration(
    args: DeleteEdgeConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteEdgeConfigurationCommandOutput) => void
  ): void;
  deleteSignalingChannel(
    args: DeleteSignalingChannelCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteSignalingChannelCommandOutput>;
  deleteSignalingChannel(
    args: DeleteSignalingChannelCommandInput,
    cb: (err: any, data?: DeleteSignalingChannelCommandOutput) => void
  ): void;
  deleteSignalingChannel(
    args: DeleteSignalingChannelCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteSignalingChannelCommandOutput) => void
  ): void;
  deleteStream(
    args: DeleteStreamCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteStreamCommandOutput>;
  deleteStream(
    args: DeleteStreamCommandInput,
    cb: (err: any, data?: DeleteStreamCommandOutput) => void
  ): void;
  deleteStream(
    args: DeleteStreamCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteStreamCommandOutput) => void
  ): void;
  describeEdgeConfiguration(
    args: DescribeEdgeConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeEdgeConfigurationCommandOutput>;
  describeEdgeConfiguration(
    args: DescribeEdgeConfigurationCommandInput,
    cb: (err: any, data?: DescribeEdgeConfigurationCommandOutput) => void
  ): void;
  describeEdgeConfiguration(
    args: DescribeEdgeConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeEdgeConfigurationCommandOutput) => void
  ): void;
  describeImageGenerationConfiguration(
    args: DescribeImageGenerationConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeImageGenerationConfigurationCommandOutput>;
  describeImageGenerationConfiguration(
    args: DescribeImageGenerationConfigurationCommandInput,
    cb: (
      err: any,
      data?: DescribeImageGenerationConfigurationCommandOutput
    ) => void
  ): void;
  describeImageGenerationConfiguration(
    args: DescribeImageGenerationConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: DescribeImageGenerationConfigurationCommandOutput
    ) => void
  ): void;
  describeMappedResourceConfiguration(
    args: DescribeMappedResourceConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeMappedResourceConfigurationCommandOutput>;
  describeMappedResourceConfiguration(
    args: DescribeMappedResourceConfigurationCommandInput,
    cb: (
      err: any,
      data?: DescribeMappedResourceConfigurationCommandOutput
    ) => void
  ): void;
  describeMappedResourceConfiguration(
    args: DescribeMappedResourceConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: DescribeMappedResourceConfigurationCommandOutput
    ) => void
  ): void;
  describeMediaStorageConfiguration(
    args: DescribeMediaStorageConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeMediaStorageConfigurationCommandOutput>;
  describeMediaStorageConfiguration(
    args: DescribeMediaStorageConfigurationCommandInput,
    cb: (
      err: any,
      data?: DescribeMediaStorageConfigurationCommandOutput
    ) => void
  ): void;
  describeMediaStorageConfiguration(
    args: DescribeMediaStorageConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: DescribeMediaStorageConfigurationCommandOutput
    ) => void
  ): void;
  describeNotificationConfiguration(
    args: DescribeNotificationConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeNotificationConfigurationCommandOutput>;
  describeNotificationConfiguration(
    args: DescribeNotificationConfigurationCommandInput,
    cb: (
      err: any,
      data?: DescribeNotificationConfigurationCommandOutput
    ) => void
  ): void;
  describeNotificationConfiguration(
    args: DescribeNotificationConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: DescribeNotificationConfigurationCommandOutput
    ) => void
  ): void;
  describeSignalingChannel(
    args: DescribeSignalingChannelCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeSignalingChannelCommandOutput>;
  describeSignalingChannel(
    args: DescribeSignalingChannelCommandInput,
    cb: (err: any, data?: DescribeSignalingChannelCommandOutput) => void
  ): void;
  describeSignalingChannel(
    args: DescribeSignalingChannelCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeSignalingChannelCommandOutput) => void
  ): void;
  describeStream(
    args: DescribeStreamCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeStreamCommandOutput>;
  describeStream(
    args: DescribeStreamCommandInput,
    cb: (err: any, data?: DescribeStreamCommandOutput) => void
  ): void;
  describeStream(
    args: DescribeStreamCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeStreamCommandOutput) => void
  ): void;
  getDataEndpoint(
    args: GetDataEndpointCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetDataEndpointCommandOutput>;
  getDataEndpoint(
    args: GetDataEndpointCommandInput,
    cb: (err: any, data?: GetDataEndpointCommandOutput) => void
  ): void;
  getDataEndpoint(
    args: GetDataEndpointCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetDataEndpointCommandOutput) => void
  ): void;
  getSignalingChannelEndpoint(
    args: GetSignalingChannelEndpointCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetSignalingChannelEndpointCommandOutput>;
  getSignalingChannelEndpoint(
    args: GetSignalingChannelEndpointCommandInput,
    cb: (err: any, data?: GetSignalingChannelEndpointCommandOutput) => void
  ): void;
  getSignalingChannelEndpoint(
    args: GetSignalingChannelEndpointCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetSignalingChannelEndpointCommandOutput) => void
  ): void;
  listEdgeAgentConfigurations(
    args: ListEdgeAgentConfigurationsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListEdgeAgentConfigurationsCommandOutput>;
  listEdgeAgentConfigurations(
    args: ListEdgeAgentConfigurationsCommandInput,
    cb: (err: any, data?: ListEdgeAgentConfigurationsCommandOutput) => void
  ): void;
  listEdgeAgentConfigurations(
    args: ListEdgeAgentConfigurationsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListEdgeAgentConfigurationsCommandOutput) => void
  ): void;
  listSignalingChannels(
    args: ListSignalingChannelsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListSignalingChannelsCommandOutput>;
  listSignalingChannels(
    args: ListSignalingChannelsCommandInput,
    cb: (err: any, data?: ListSignalingChannelsCommandOutput) => void
  ): void;
  listSignalingChannels(
    args: ListSignalingChannelsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListSignalingChannelsCommandOutput) => void
  ): void;
  listStreams(
    args: ListStreamsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListStreamsCommandOutput>;
  listStreams(
    args: ListStreamsCommandInput,
    cb: (err: any, data?: ListStreamsCommandOutput) => void
  ): void;
  listStreams(
    args: ListStreamsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListStreamsCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListTagsForResourceCommandOutput>;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  listTagsForStream(
    args: ListTagsForStreamCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListTagsForStreamCommandOutput>;
  listTagsForStream(
    args: ListTagsForStreamCommandInput,
    cb: (err: any, data?: ListTagsForStreamCommandOutput) => void
  ): void;
  listTagsForStream(
    args: ListTagsForStreamCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListTagsForStreamCommandOutput) => void
  ): void;
  startEdgeConfigurationUpdate(
    args: StartEdgeConfigurationUpdateCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<StartEdgeConfigurationUpdateCommandOutput>;
  startEdgeConfigurationUpdate(
    args: StartEdgeConfigurationUpdateCommandInput,
    cb: (err: any, data?: StartEdgeConfigurationUpdateCommandOutput) => void
  ): void;
  startEdgeConfigurationUpdate(
    args: StartEdgeConfigurationUpdateCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: StartEdgeConfigurationUpdateCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<TagResourceCommandOutput>;
  tagResource(
    args: TagResourceCommandInput,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  tagStream(
    args: TagStreamCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<TagStreamCommandOutput>;
  tagStream(
    args: TagStreamCommandInput,
    cb: (err: any, data?: TagStreamCommandOutput) => void
  ): void;
  tagStream(
    args: TagStreamCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: TagStreamCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UntagResourceCommandOutput>;
  untagResource(
    args: UntagResourceCommandInput,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  untagStream(
    args: UntagStreamCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UntagStreamCommandOutput>;
  untagStream(
    args: UntagStreamCommandInput,
    cb: (err: any, data?: UntagStreamCommandOutput) => void
  ): void;
  untagStream(
    args: UntagStreamCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UntagStreamCommandOutput) => void
  ): void;
  updateDataRetention(
    args: UpdateDataRetentionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateDataRetentionCommandOutput>;
  updateDataRetention(
    args: UpdateDataRetentionCommandInput,
    cb: (err: any, data?: UpdateDataRetentionCommandOutput) => void
  ): void;
  updateDataRetention(
    args: UpdateDataRetentionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateDataRetentionCommandOutput) => void
  ): void;
  updateImageGenerationConfiguration(
    args: UpdateImageGenerationConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateImageGenerationConfigurationCommandOutput>;
  updateImageGenerationConfiguration(
    args: UpdateImageGenerationConfigurationCommandInput,
    cb: (
      err: any,
      data?: UpdateImageGenerationConfigurationCommandOutput
    ) => void
  ): void;
  updateImageGenerationConfiguration(
    args: UpdateImageGenerationConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: UpdateImageGenerationConfigurationCommandOutput
    ) => void
  ): void;
  updateMediaStorageConfiguration(
    args: UpdateMediaStorageConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateMediaStorageConfigurationCommandOutput>;
  updateMediaStorageConfiguration(
    args: UpdateMediaStorageConfigurationCommandInput,
    cb: (err: any, data?: UpdateMediaStorageConfigurationCommandOutput) => void
  ): void;
  updateMediaStorageConfiguration(
    args: UpdateMediaStorageConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateMediaStorageConfigurationCommandOutput) => void
  ): void;
  updateNotificationConfiguration(
    args: UpdateNotificationConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateNotificationConfigurationCommandOutput>;
  updateNotificationConfiguration(
    args: UpdateNotificationConfigurationCommandInput,
    cb: (err: any, data?: UpdateNotificationConfigurationCommandOutput) => void
  ): void;
  updateNotificationConfiguration(
    args: UpdateNotificationConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateNotificationConfigurationCommandOutput) => void
  ): void;
  updateSignalingChannel(
    args: UpdateSignalingChannelCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateSignalingChannelCommandOutput>;
  updateSignalingChannel(
    args: UpdateSignalingChannelCommandInput,
    cb: (err: any, data?: UpdateSignalingChannelCommandOutput) => void
  ): void;
  updateSignalingChannel(
    args: UpdateSignalingChannelCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateSignalingChannelCommandOutput) => void
  ): void;
  updateStream(
    args: UpdateStreamCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateStreamCommandOutput>;
  updateStream(
    args: UpdateStreamCommandInput,
    cb: (err: any, data?: UpdateStreamCommandOutput) => void
  ): void;
  updateStream(
    args: UpdateStreamCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateStreamCommandOutput) => void
  ): void;
}
export declare class KinesisVideo
  extends KinesisVideoClient
  implements KinesisVideo {}
