import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  CreateSignalingChannelInput,
  CreateSignalingChannelOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface CreateSignalingChannelCommandInput
  extends CreateSignalingChannelInput {}
export interface CreateSignalingChannelCommandOutput
  extends CreateSignalingChannelOutput,
    __MetadataBearer {}
export declare class CreateSignalingChannelCommand extends $Command<
  CreateSignalingChannelCommandInput,
  CreateSignalingChannelCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: CreateSignalingChannelCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: CreateSignalingChannelCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    CreateSignalingChannelCommandInput,
    CreateSignalingChannelCommandOutput
  >;
  private serialize;
  private deserialize;
}
