import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  DeleteEdgeConfigurationInput,
  DeleteEdgeConfigurationOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface DeleteEdgeConfigurationCommandInput
  extends DeleteEdgeConfigurationInput {}
export interface DeleteEdgeConfigurationCommandOutput
  extends DeleteEdgeConfigurationOutput,
    __MetadataBearer {}
export declare class DeleteEdgeConfigurationCommand extends $Command<
  DeleteEdgeConfigurationCommandInput,
  DeleteEdgeConfigurationCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: DeleteEdgeConfigurationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DeleteEdgeConfigurationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DeleteEdgeConfigurationCommandInput,
    DeleteEdgeConfigurationCommandOutput
  >;
  private serialize;
  private deserialize;
}
