import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  DeleteSignalingChannelInput,
  DeleteSignalingChannelOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface DeleteSignalingChannelCommandInput
  extends DeleteSignalingChannelInput {}
export interface DeleteSignalingChannelCommandOutput
  extends DeleteSignalingChannelOutput,
    __MetadataBearer {}
export declare class DeleteSignalingChannelCommand extends $Command<
  DeleteSignalingChannelCommandInput,
  DeleteSignalingChannelCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: DeleteSignalingChannelCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DeleteSignalingChannelCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DeleteSignalingChannelCommandInput,
    DeleteSignalingChannelCommandOutput
  >;
  private serialize;
  private deserialize;
}
