import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  DescribeEdgeConfigurationInput,
  DescribeEdgeConfigurationOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface DescribeEdgeConfigurationCommandInput
  extends DescribeEdgeConfigurationInput {}
export interface DescribeEdgeConfigurationCommandOutput
  extends DescribeEdgeConfigurationOutput,
    __MetadataBearer {}
export declare class DescribeEdgeConfigurationCommand extends $Command<
  DescribeEdgeConfigurationCommandInput,
  DescribeEdgeConfigurationCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: DescribeEdgeConfigurationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DescribeEdgeConfigurationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DescribeEdgeConfigurationCommandInput,
    DescribeEdgeConfigurationCommandOutput
  >;
  private serialize;
  private deserialize;
}
