import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  DescribeImageGenerationConfigurationInput,
  DescribeImageGenerationConfigurationOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface DescribeImageGenerationConfigurationCommandInput
  extends DescribeImageGenerationConfigurationInput {}
export interface DescribeImageGenerationConfigurationCommandOutput
  extends DescribeImageGenerationConfigurationOutput,
    __MetadataBearer {}
export declare class DescribeImageGenerationConfigurationCommand extends $Command<
  DescribeImageGenerationConfigurationCommandInput,
  DescribeImageGenerationConfigurationCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: DescribeImageGenerationConfigurationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DescribeImageGenerationConfigurationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DescribeImageGenerationConfigurationCommandInput,
    DescribeImageGenerationConfigurationCommandOutput
  >;
  private serialize;
  private deserialize;
}
