import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  DescribeMappedResourceConfigurationInput,
  DescribeMappedResourceConfigurationOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface DescribeMappedResourceConfigurationCommandInput
  extends DescribeMappedResourceConfigurationInput {}
export interface DescribeMappedResourceConfigurationCommandOutput
  extends DescribeMappedResourceConfigurationOutput,
    __MetadataBearer {}
export declare class DescribeMappedResourceConfigurationCommand extends $Command<
  DescribeMappedResourceConfigurationCommandInput,
  DescribeMappedResourceConfigurationCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: DescribeMappedResourceConfigurationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DescribeMappedResourceConfigurationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DescribeMappedResourceConfigurationCommandInput,
    DescribeMappedResourceConfigurationCommandOutput
  >;
  private serialize;
  private deserialize;
}
