import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  DescribeMediaStorageConfigurationInput,
  DescribeMediaStorageConfigurationOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface DescribeMediaStorageConfigurationCommandInput
  extends DescribeMediaStorageConfigurationInput {}
export interface DescribeMediaStorageConfigurationCommandOutput
  extends DescribeMediaStorageConfigurationOutput,
    __MetadataBearer {}
export declare class DescribeMediaStorageConfigurationCommand extends $Command<
  DescribeMediaStorageConfigurationCommandInput,
  DescribeMediaStorageConfigurationCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: DescribeMediaStorageConfigurationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DescribeMediaStorageConfigurationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DescribeMediaStorageConfigurationCommandInput,
    DescribeMediaStorageConfigurationCommandOutput
  >;
  private serialize;
  private deserialize;
}
