import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  DescribeNotificationConfigurationInput,
  DescribeNotificationConfigurationOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface DescribeNotificationConfigurationCommandInput
  extends DescribeNotificationConfigurationInput {}
export interface DescribeNotificationConfigurationCommandOutput
  extends DescribeNotificationConfigurationOutput,
    __MetadataBearer {}
export declare class DescribeNotificationConfigurationCommand extends $Command<
  DescribeNotificationConfigurationCommandInput,
  DescribeNotificationConfigurationCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: DescribeNotificationConfigurationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DescribeNotificationConfigurationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DescribeNotificationConfigurationCommandInput,
    DescribeNotificationConfigurationCommandOutput
  >;
  private serialize;
  private deserialize;
}
