import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  DescribeSignalingChannelInput,
  DescribeSignalingChannelOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface DescribeSignalingChannelCommandInput
  extends DescribeSignalingChannelInput {}
export interface DescribeSignalingChannelCommandOutput
  extends DescribeSignalingChannelOutput,
    __MetadataBearer {}
export declare class DescribeSignalingChannelCommand extends $Command<
  DescribeSignalingChannelCommandInput,
  DescribeSignalingChannelCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: DescribeSignalingChannelCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DescribeSignalingChannelCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DescribeSignalingChannelCommandInput,
    DescribeSignalingChannelCommandOutput
  >;
  private serialize;
  private deserialize;
}
