import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  ListEdgeAgentConfigurationsInput,
  ListEdgeAgentConfigurationsOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListEdgeAgentConfigurationsCommandInput
  extends ListEdgeAgentConfigurationsInput {}
export interface ListEdgeAgentConfigurationsCommandOutput
  extends ListEdgeAgentConfigurationsOutput,
    __MetadataBearer {}
export declare class ListEdgeAgentConfigurationsCommand extends $Command<
  ListEdgeAgentConfigurationsCommandInput,
  ListEdgeAgentConfigurationsCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: ListEdgeAgentConfigurationsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListEdgeAgentConfigurationsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListEdgeAgentConfigurationsCommandInput,
    ListEdgeAgentConfigurationsCommandOutput
  >;
  private serialize;
  private deserialize;
}
