import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  ListSignalingChannelsInput,
  ListSignalingChannelsOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListSignalingChannelsCommandInput
  extends ListSignalingChannelsInput {}
export interface ListSignalingChannelsCommandOutput
  extends ListSignalingChannelsOutput,
    __MetadataBearer {}
export declare class ListSignalingChannelsCommand extends $Command<
  ListSignalingChannelsCommandInput,
  ListSignalingChannelsCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: ListSignalingChannelsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListSignalingChannelsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListSignalingChannelsCommandInput,
    ListSignalingChannelsCommandOutput
  >;
  private serialize;
  private deserialize;
}
