import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  StartEdgeConfigurationUpdateInput,
  StartEdgeConfigurationUpdateOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface StartEdgeConfigurationUpdateCommandInput
  extends StartEdgeConfigurationUpdateInput {}
export interface StartEdgeConfigurationUpdateCommandOutput
  extends StartEdgeConfigurationUpdateOutput,
    __MetadataBearer {}
export declare class StartEdgeConfigurationUpdateCommand extends $Command<
  StartEdgeConfigurationUpdateCommandInput,
  StartEdgeConfigurationUpdateCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: StartEdgeConfigurationUpdateCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: StartEdgeConfigurationUpdateCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    StartEdgeConfigurationUpdateCommandInput,
    StartEdgeConfigurationUpdateCommandOutput
  >;
  private serialize;
  private deserialize;
}
