import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import { TagStreamInput, TagStreamOutput } from "../models/models_0";
export { __MetadataBearer, $Command };
export interface TagStreamCommandInput extends TagStreamInput {}
export interface TagStreamCommandOutput
  extends TagStreamOutput,
    __MetadataBearer {}
export declare class TagStreamCommand extends $Command<
  TagStreamCommandInput,
  TagStreamCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: TagStreamCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: TagStreamCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<TagStreamCommandInput, TagStreamCommandOutput>;
  private serialize;
  private deserialize;
}
