import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  UpdateImageGenerationConfigurationInput,
  UpdateImageGenerationConfigurationOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface UpdateImageGenerationConfigurationCommandInput
  extends UpdateImageGenerationConfigurationInput {}
export interface UpdateImageGenerationConfigurationCommandOutput
  extends UpdateImageGenerationConfigurationOutput,
    __MetadataBearer {}
export declare class UpdateImageGenerationConfigurationCommand extends $Command<
  UpdateImageGenerationConfigurationCommandInput,
  UpdateImageGenerationConfigurationCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: UpdateImageGenerationConfigurationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateImageGenerationConfigurationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    UpdateImageGenerationConfigurationCommandInput,
    UpdateImageGenerationConfigurationCommandOutput
  >;
  private serialize;
  private deserialize;
}
