import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  UpdateMediaStorageConfigurationInput,
  UpdateMediaStorageConfigurationOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface UpdateMediaStorageConfigurationCommandInput
  extends UpdateMediaStorageConfigurationInput {}
export interface UpdateMediaStorageConfigurationCommandOutput
  extends UpdateMediaStorageConfigurationOutput,
    __MetadataBearer {}
export declare class UpdateMediaStorageConfigurationCommand extends $Command<
  UpdateMediaStorageConfigurationCommandInput,
  UpdateMediaStorageConfigurationCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: UpdateMediaStorageConfigurationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateMediaStorageConfigurationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    UpdateMediaStorageConfigurationCommandInput,
    UpdateMediaStorageConfigurationCommandOutput
  >;
  private serialize;
  private deserialize;
}
