import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  UpdateNotificationConfigurationInput,
  UpdateNotificationConfigurationOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface UpdateNotificationConfigurationCommandInput
  extends UpdateNotificationConfigurationInput {}
export interface UpdateNotificationConfigurationCommandOutput
  extends UpdateNotificationConfigurationOutput,
    __MetadataBearer {}
export declare class UpdateNotificationConfigurationCommand extends $Command<
  UpdateNotificationConfigurationCommandInput,
  UpdateNotificationConfigurationCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: UpdateNotificationConfigurationCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateNotificationConfigurationCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    UpdateNotificationConfigurationCommandInput,
    UpdateNotificationConfigurationCommandOutput
  >;
  private serialize;
  private deserialize;
}
