import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  KinesisVideoClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KinesisVideoClient";
import {
  UpdateSignalingChannelInput,
  UpdateSignalingChannelOutput,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface UpdateSignalingChannelCommandInput
  extends UpdateSignalingChannelInput {}
export interface UpdateSignalingChannelCommandOutput
  extends UpdateSignalingChannelOutput,
    __MetadataBearer {}
export declare class UpdateSignalingChannelCommand extends $Command<
  UpdateSignalingChannelCommandInput,
  UpdateSignalingChannelCommandOutput,
  KinesisVideoClientResolvedConfig
> {
  readonly input: UpdateSignalingChannelCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateSignalingChannelCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KinesisVideoClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    UpdateSignalingChannelCommandInput,
    UpdateSignalingChannelCommandOutput
  >;
  private serialize;
  private deserialize;
}
